
// SmeexCommonClassesTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SmeexCommonClassesTest.h"
#include "SmeexCommonClassesTestDlg.h"
#include "SmeexHandler.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSmeexCommonClassesTestDlg dialog




CSmeexCommonClassesTestDlg::CSmeexCommonClassesTestDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSmeexCommonClassesTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	f_lAddressID=0;
}

void CSmeexCommonClassesTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSmeexCommonClassesTestDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXPORT, &CSmeexCommonClassesTestDlg::OnBnClickedExport)
	ON_BN_CLICKED(IDC_IMPORT, &CSmeexCommonClassesTestDlg::OnBnClickedImport)
END_MESSAGE_MAP()


// CSmeexCommonClassesTestDlg message handlers

BOOL CSmeexCommonClassesTestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSmeexCommonClassesTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSmeexCommonClassesTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSmeexCommonClassesTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CSmeexCommonClassesTestDlg::OnBnClickedExport()
{
	try {
		CWaitCursor wait;
		structSmeexOnePatientComm sSmeexOnePatientComm;
		INIT_SMEEXONEPATIENTCOMMSTRUCT(sSmeexOnePatientComm);
		//
		FillSmeexOnePatientCommStruct(sSmeexOnePatientComm);
		//
		CString strFile = GetProgPath(); 
		strFile += _T("exportSMEEX.smeex");
		CSmeexHandler smeexHandler;
		BOOL bStatus = smeexHandler.DoSmeexExport(strFile,&sSmeexOnePatientComm);
		if (!bStatus) {
			ASSERT(FALSE);
			return;
		}
		AfxMessageBox(_T("file 'exportSMEEX.smeex' successfully exported!"));
	}
	catch (CException &e)
	{
		TCHAR msg[512]; 
		e.GetErrorMessage(msg, sizeof(msg) / sizeof(TCHAR));
		AfxMessageBox(msg); 
		e.Delete(); 
	}
	catch(System::Exception ^e) {
		CString strMessage = e->Message;
		AfxMessageBox(strMessage);
	}
	catch(...) {
		AfxMessageBox(_T("Unexpected error occurred"));
	}
}

void CSmeexCommonClassesTestDlg::OnBnClickedImport()
{
	try {
		CWaitCursor wait;
		CString strFile = GetProgPath(); 
		strFile += _T("exportSMEEX.smeex");
		TRACE("%ls\n",strFile);
		CFileStatus status;
		if (!CFile::GetStatus(strFile,status)) {
			ASSERT(FALSE);
			return;
		}
		CString strAttachmentDir = GetProgPath();
		strAttachmentDir += _T("temp");
		CreateDirectory(strAttachmentDir,NULL); 

		structSmeexOnePatientComm sSmeexOnePatientComm;
		CSmeexHandler smeexHandler;
		smeexHandler.DoSmeexImport(strFile,strAttachmentDir,&sSmeexOnePatientComm);
		AfxMessageBox(_T("file 'exportSMEEX.smeex' successfully imported!"));
	}
	catch (CException &e)
	{
		TCHAR msg[512]; 
		e.GetErrorMessage(msg, sizeof(msg) / sizeof(TCHAR));
		AfxMessageBox(msg); 
		e.Delete(); 
	}
	catch(System::Exception ^e) {
		CString strMessage = e->Message;
		AfxMessageBox(strMessage);
	}
	catch(...) {
		AfxMessageBox(_T("Unexpected error occurred"));
	}
}

CString CSmeexCommonClassesTestDlg::GetProgPath()
{
	TCHAR szPathName[_MAX_PATH]; 
	::GetModuleFileName(NULL, szPathName, _MAX_PATH); 
	LPTSTR pszFileName = _tcsrchr(szPathName, '\\') + 1; 
	*pszFileName = '\0'; 
	CString strPath = szPathName; 
	strPath.Replace(_T("\\Debug\\"),_T("\\Release\\"));
	return strPath;
}

void CSmeexCommonClassesTestDlg::FillSmeexOnePatientCommStruct(structSmeexOnePatientComm &sSmeexOnePatientComm)
{
	INIT_SMEEXONEPATIENTCOMMSTRUCT(sSmeexOnePatientComm);
	CString strSmeexID;
	strSmeexID.Format(_T("2.16.756.5.30.1.106.1.10.%d"),GetTickCount());
	//strSmeexID.Format(_T("0.0.0.123.456.%d"),GetTickCount());
	sSmeexOnePatientComm.sSmeexArchive.strSmeexID = strSmeexID;
	sSmeexOnePatientComm.sSmeexArchive.strTitle = _T("Smeex Demo-Export: SmeexOnePatientComm");
	sSmeexOnePatientComm.sSmeexArchive.strLanguage = SMEEX_STR_LANGUAGE_GERMAN;
	//ProcessingInfo
	sSmeexOnePatientComm.sProcessingInfo.dDate = COleDateTime::GetCurrentTime();
	sSmeexOnePatientComm.sSmeexArchive.strTitle = _T("Smeex Demo-Export: SmeexOnePatientComm");
	//
	structSmeexAddress *psAddress;
	//author
	psAddress = &sSmeexOnePatientComm.sProcessingInfo.sAuthor;
	psAddress->lID = ++f_lAddressID;
	psAddress->eSmeexAddressType = eCompanySmeexAddressType;
	psAddress->strLastName = _T("TMR AG");
	psAddress->strPoBox = _T("");
	psAddress->strStreet = _T("Ribigasse 3-5");
	psAddress->strZip = _T("4434");
	psAddress->strCity = _T("Hlstein");
	psAddress->strCountry = _T("CH");
	//
/*
	psAddress->strPhoneOffice = _T("061 956 99 00");
	psAddress->strPhoneHome = _T("061 956 99 00");
	psAddress->strNatelOffice = _T("061 956 99 00");
	psAddress->strNatelHome = _T("061 956 99 00");
	psAddress->strFaxOffice = _T("061 956 99 00");
	psAddress->strFaxHome = _T("061 956 99 00");
*/
	psAddress->strUrlOffice = _T("www.tmr.ch");
	psAddress->strUrlHome = _T("www.tmr.ch");
	psAddress->strMailOffice = _T("info@tmr.ch");
	psAddress->strMailHome = _T("tmr@tmr.ch");
	//recipient
	sSmeexOnePatientComm.sProcessingInfo.sRecipient = sSmeexOnePatientComm.sProcessingInfo.sAuthor;
	sSmeexOnePatientComm.sProcessingInfo.sRecipient.lID = ++f_lAddressID;
	//software
	sSmeexOnePatientComm.sProcessingInfo.sSoftware.strName = _T("WinMed");
	sSmeexOnePatientComm.sProcessingInfo.sSoftware.strVersion = _T("3.0");
	sSmeexOnePatientComm.sProcessingInfo.sSoftware.strCopyright = _T("Copyright by TMR AG");
	sSmeexOnePatientComm.sProcessingInfo.sSoftware.sManufacturer = sSmeexOnePatientComm.sProcessingInfo.sAuthor;
	sSmeexOnePatientComm.sProcessingInfo.sSoftware.sManufacturer.lID = ++f_lAddressID;
	//Patient
	psAddress = &sSmeexOnePatientComm.sPatientInfo.sPatient.sAddress;
	psAddress->lID = ++f_lAddressID;
	psAddress->eSmeexAddressType = ePersonSmeexAddressType;
	psAddress->strLastName = _T("Eggenberger");
	psAddress->strFirstName = _T("Rolf");
	psAddress->strPoBox = _T("");
	psAddress->strStreet = _T("Ribigasse 3-5");
	psAddress->strZip = _T("4434");
	psAddress->strCity = _T("Hlstein");
	psAddress->strCountry = _T("CH");
	//
	sSmeexOnePatientComm.sPatientInfo.lID = 111;
	//
	sSmeexOnePatientComm.sPatientInfo.sPatient.lAddressRefID = psAddress->lID;
	sSmeexOnePatientComm.sPatientInfo.sPatient.lPatientID = 111;
	sSmeexOnePatientComm.sPatientInfo.sPatient.eStatusType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumStatusType::Active;
	sSmeexOnePatientComm.sPatientInfo.sPatient.dBirthdate = COleDateTime(1964,2,28,0,0,0);
	sSmeexOnePatientComm.sPatientInfo.sPatient.strSsn = _T("");
	sSmeexOnePatientComm.sPatientInfo.sPatient.strProfession = _T("");
	sSmeexOnePatientComm.sPatientInfo.sPatient.strNationality = _T("");
	sSmeexOnePatientComm.sPatientInfo.sPatient.strDenomination = _T("");
	sSmeexOnePatientComm.sPatientInfo.sPatient.strHmoAffiliation = _T("");
	sSmeexOnePatientComm.sPatientInfo.sPatient.strNationalLanguage = SMEEX_STR_LANGUAGE_GERMAN;
	sSmeexOnePatientComm.sPatientInfo.sPatient.eEthnicity = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumEthnicity::Caucasian; 
	sSmeexOnePatientComm.sPatientInfo.sPatient.eMaritalStatus = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress::EnumMaritalStatus::Married;
	//
	BOOL bAddDiag = TRUE;
	BOOL bAddMedi = TRUE;
	BOOL bAddDoc = TRUE;
	//diagnosis
	if (bAddDiag) {
		long lDiagnosisID = 0;
		long lParentID = 0;
		{
			_bstr_t strName = _T("Meine Diganose");
			_bstr_t strCode = _T("");
			structSmeexDiagnosis s;
			INIT_SMEEXDIAGNOSISSTRUCT(s);
			s.strCodingEntryCode = strCode;
			s.strCodingEntryName = strName;
			s.eCodingType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::EnumCodingType::FreeText;
			s.dDate = COleDateTime(2010,3,15,0,0,0);
			s.lID = ++lDiagnosisID;
			s.lParentID = lParentID;
			s.bIsActive = FALSE;
			s.strName = strName;
			//
			SmeexDiagnosisArray arDiag;
			arDiag.push_back(s);
			sSmeexOnePatientComm.sPatientInfo.sKg.mapDiagnosis[lParentID] = arDiag;
		}
	}
	//Medication
	if (bAddMedi) {
		long lMedicationID = 0;
		{
			_bstr_t strMediname = _T("ASPEGIC Plv 500 mg Btl 20 Stk");
			_bstr_t strCode = _T("2734982");
			structSmeexMedication s;
			INIT_SMEEXMEDICATIONSTRUCT(s);
			s.strCodingEntryCode = strCode;
			s.strCodingEntryName = strMediname;
			s.eCodingType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication::EnumCodingType::PharmaCode;
			s.dDate = COleDateTime(2010,3,15,0,0,0);
			//s.lDocumentRefID;
			s.lID = ++lMedicationID;
			s.bIsActive = FALSE;
			//s.bIsChronic;
			//s.bIsDisposing;
			s.strName = strMediname;
			//s.strShortName;
			structSmeexPosology sPosology;
			INIT_SMEEXPOSOLOGYSTRUCT(sPosology);
			sPosology.dDateBegin = s.dDate;
			//sPosology.dDateEnd;
			//sPosology.lDocumentRefID;
			//sPosology.dQuantityEvening;
			//sPosology.dQuantityMorning;
			//sPosology.dQuantityNight;
			//sPosology.dQuantityNoon;
			sPosology.strRemark = _T("bei bdearf");
			s.arPosology.push_back(sPosology);
			sSmeexOnePatientComm.sPatientInfo.sKg.arMedication.push_back(s);
		}
/*
		{
			_bstr_t strMediname = _T("RHINOMER Nasenspray Fl 60 ml");
			_bstr_t strCode = _T("7640114899997");
			structSmeexMedication s;
			INIT_SMEEXMEDICATIONSTRUCT(s);
			s.strCodingEntryCode = strCode;
			s.strCodingEntryName = strMediname;
			s.eCodingType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication::EnumCodingType::Ean13Code;
			s.dDate = COleDateTime(2010,3,15,0,0,0);
			//s.lDocumentRefID;
			s.lID = ++lMedicationID;
			s.bIsActive = FALSE;
			//s.bIsChronic;
			//s.bIsDisposing;
			s.strName = strMediname;
			//s.strShortName;
			s.dPosologyDateBegin = s.dDate;
			//s.dPosologyDateEnd;
			//s.lPosologyDocumentRefID;
			s.dPosologyQuantityMorning = 1.0;
			s.dPosologyQuantityNoon = 1.0;
			s.dPosologyQuantityEvening = 1.0;
			s.dPosologyQuantityNight = 1.0;
			s.strPosologyRemark = _T("bei bdearf");
			sSmeexOnePatientComm.sPatientInfo.sKg.arMedication.push_back(s);
		}
*/
	}
	//documents
	if (bAddDoc) {
		CString strFile = GetProgPath(); 
		strFile += _T("document2export.txt");
		TRACE("%ls\n",strFile);
		CFileStatus status;
		if (!CFile::GetStatus(strFile,status)) {
			CStdioFile cf;
			CFileException e;
			if (!cf.Open(strFile,CFile::modeCreate|CFile::modeNoTruncate|CFile::modeWrite,&e)) {
				ASSERT(FALSE);
			}
			else {
				if (cf.GetLength()==0) {
					CString strLine = _T("sample for attachment\n");
					cf.WriteString(strLine);
				}
			}
		}
		long lDocumntID = 0;
		if (CFile::GetStatus(strFile,status)) {
			//
			{
				++lDocumntID;
				structSmeexDocumentTree sDocTree;
				INIT_SMEEXDOCUMENTTREESTRUCT(sDocTree);
				sDocTree.lDocumentTreeChildID = 0;
				sDocTree.strName = "documents";
				SmeexDocumentLeafArray arLeaf;
				structSmeexDocumentLeaf sLeaf;
				INIT_SMEEXDOCUMENTLEAFSTRUCT(sLeaf);
				//sLeaf.strFilepath = strFile;
				sLeaf.strComment = _T("dies ist ein Kommentar");
				sLeaf.dDate = COleDateTime::GetCurrentTime();
				sLeaf.lID = lDocumntID;
				sLeaf.strName = _T("mein Titel");
				sLeaf.sSmeexDocument.strFilepath = strFile;
				sLeaf.sSmeexDocument.lID = lDocumntID;
				sLeaf.sSmeexDocument.strMimeType = _T("text/plain");
				//INIT_SMEEXADDRESSSTRUCT(s.sProducerAddress);
				sLeaf.sSmeexDocument.lSize = (long)status.m_size;
				arLeaf.push_back(sLeaf);
				if (arLeaf.size()) {
					sDocTree.mapDocumentLeaf[1] = arLeaf;
					sSmeexOnePatientComm.sPatientInfo.arDocumentTree.push_back(sDocTree);
				}
			}
		}
	}
}
